## ros-foxy-rttest 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rttest)

if(WIN32 OR APPLE OR ANDROID)
  message(STATUS "rttest is only supported on Linux, skipping...")
  return()
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

find_package(ament_cmake QUIET)

# ament build if it was found
if(${ament_cmake_FOUND})
  find_package(Threads REQUIRED)

  include_directories(include)
  add_library(rttest SHARED src/rttest.cpp)
  target_link_libraries(rttest m stdc++ ${CMAKE_THREAD_LIBS_INIT})

  ament_export_include_directories(include)
  set(exported_libraries rttest pthread)
  ament_export_libraries(${exported_libraries})

  if(BUILD_TESTING)
    find_package(ament_cmake_gtest REQUIRED)
    find_package(ament_lint_auto REQUIRED)
    ament_lint_auto_find_test_dependencies()

    ament_add_gtest(
      gtest_rttest_api
      "test/test_api.cpp"
      TIMEOUT 15
    )
    if(TARGET gtest_rttest_api)
      target_link_libraries(gtest_rttest_api ${exported_libraries})
    endif()
  endif()

  ament_package()

  install(
    DIRECTORY include/
    DESTINATION include
  )

  install(
    PROGRAMS scripts/rttest_plot
    DESTINATION bin
  )

  install(
    TARGETS rttest
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
  )

else()
  message(STATUS "ament_cmake_auto not found, executing pure CMake build")
  # pure cmake build
  set(INSTALL_LIB_DIR lib CACHE PATH "install dir for libraries")
  set(INSTALL_BIN_DIR bin CACHE PATH "install dir for executables")
  set(INSTALL_INCLUDE_DIR include CACHE PATH "install dir for headers")

  set(DEF_INSTALL_CMAKE_DIR lib/cmake/rttest)
  set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "install dir for cmake files")

  find_package(Threads REQUIRED)
  add_library(rttest ${PROJECT_SOURCE_DIR}/src/rttest.cpp)
  target_link_libraries(rttest m stdc++ ${CMAKE_THREAD_LIBS_INIT})

  include_directories(rttest ${PROJECT_SOURCE_DIR}/include)

  install(TARGETS rttest
    LIBRARY DESTINATION ${INSTALL_LIB_DIR}
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
  )

  install(
    DIRECTORY include/
    DESTINATION ${INSTALL_INCLUDE_DIR})

  export(PACKAGE ${PROJECT_NAME})

  set(rttest_INCLUDE_DIR ${CMAKE_INSTALL_PREFIX}/include)
  set(rttest_LIB_DIR ${CMAKE_INSTALL_PREFIX}/lib)
  set(rttest_CMAKE_DIR
    ${CMAKE_INSTALL_PREFIX}/share/${CMAKE_PROJECT_NAME}/CMake)
  configure_file(${CMAKE_PROJECT_NAME}Config.cmake.in
    ${CMAKE_BINARY_DIR}/InstallFiles/${CMAKE_PROJECT_NAME}Config.cmake
    @ONLY)
  install(FILES
    ${CMAKE_BINARY_DIR}/InstallFiles/${CMAKE_PROJECT_NAME}Config.cmake
    DESTINATION ${rttest_CMAKE_DIR})

endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rttest_examples)

find_package(rttest REQUIRED)

link_directories(${rttest_LIBRARY_DIR})
include_directories(${rttest_INCLUDE_DIRS})

add_executable(example_loop example_loop.c)
target_link_libraries(example_loop ${rttest_LIBRARIES})

=== debian/changelog ===
ros-foxy-rttest (0.9.0-1focal) focal; urgency=high

  * Use std::bind instead of deprecated std::bind2nd (#93 <https://github.com/ros2/realtime_support/issues/93>)
  * Use a uint64_t to store the prefault_dynamic_size. (#90 <https://github.com/ros2/realtime_support/issues/90>)
  * Make dynamic prefault memory size configurable (#89 <https://github.com/ros2/realtime_support/issues/89>)
  * code style only: wrap after open parenthesis if not in one line (#88 <https://github.com/ros2/realtime_support/issues/88>)
  * Contributors: Chris Lalancette, Dirk Thomas, Michel Hidalgo, Roman Sokolkov

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 30 Apr 2020 00:00:00 -0000

ros-foxy-rttest (0.8.2-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 13 Nov 2019 00:00:00 -0000

ros-foxy-rttest (0.8.1-1focal) focal; urgency=high

  * Fix typo (#83 <https://github.com/ros2/realtime_support/issues/83>)
  * Contributors: Servando

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 23 Oct 2019 00:00:00 -0000

ros-foxy-rttest (0.8.0-1focal) focal; urgency=high

  * Switch the latency storage to int64_t (#82 <https://github.com/ros2/realtime_support/issues/82>)
  * Only return statistics if they have been calculated (#81 <https://github.com/ros2/realtime_support/issues/81>)
  * Remove non-package from ament_target_dependencies() (#79 <https://github.com/ros2/realtime_support/issues/79>)
  * Fix armhf build warnings (#78 <https://github.com/ros2/realtime_support/issues/78>)
  * Contributors: Chris Lalancette, Prajakta Gokhale, Shane Loretz

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 26 Sep 2019 00:00:00 -0000

ros-foxy-rttest (0.7.1-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 08 May 2019 00:00:00 -0000

ros-foxy-rttest (0.7.0-1focal) focal; urgency=high

  * Add section about DCO to CONTRIBUTING.md
  * Install headers into the same location when ament_cmake is not used (#72 <https://github.com/ros2/realtime_support/issues/72>)
  * Contributors: Dirk Thomas

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 14 Apr 2019 00:00:00 -0000

ros-foxy-rttest (0.6.0-1focal) focal; urgency=high

  * Drop obsolete RTLinux (#68 <https://github.com/ros2/realtime_support/issues/68>)
    RTLinux is obsolete, and both commercial and GPL editions were no longer
    maintained. Through the use of the real-time Linux kernel patch
    PREEMPT_RT, support for full preemption of critical sections, interrupt
    handlers, and "interrupt disable" code sequences can be supported.
  * Contributors: Jim Huang

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 20 Nov 2018 00:00:00 -0000

ros-foxy-rttest (0.5.0-1focal) focal; urgency=high

  * Update the maintainer (#65 <https://github.com/ros2/realtime_support/issues/65>)
  * Contributors: Chris Lalancette

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 27 Jun 2018 00:00:00 -0000

ros-foxy-rttest (0.4.0-1focal) focal; urgency=high

  * Update style to match latest uncrustify (#57 <https://github.com/ros2/realtime_support/issues/57>)
  * 0.0.3
  * Update style to satisfy new flake8 plugins (#56 <https://github.com/ros2/realtime_support/issues/56>)
  * Use CMAKE_X_STANDARD and check compiler rather than platform
  * Comply with flake8 + flake8-import-order linters (#52 <https://github.com/ros2/realtime_support/issues/52>)
  * Require CMake 3.5
  * C++14 (#50 <https://github.com/ros2/realtime_support/issues/50>)
  * Remove usage of internal variables and noops (#43 <https://github.com/ros2/realtime_support/issues/43>)
  * Add schema to manifest files
  * Disable on Android (#41 <https://github.com/ros2/realtime_support/issues/41>)
  * Use CTest BUILD_TESTING (#38 <https://github.com/ros2/realtime_support/issues/38>)
  * uint32 -> uint64 in a few places for time calculation #33 <https://github.com/ros2/realtime_support/issues/33>)
  * Store filename on heap, add more checks for null pointers (#29 <https://github.com/ros2/realtime_support/issues/29>)
  * Fix memory management of rttest_sample_buffer (#22 <https://github.com/ros2/realtime_support/issues/22>)
  * Fix boundary check (#20 <https://github.com/ros2/realtime_support/issues/20>)
  * Reorganize realtime_support repository (#16)
    
    Add tlsf_cpp repo
    
    Move rttest into subfolder
  * Contributors: Dirk Thomas, Esteve Fernandez, Jackie Kay, Mikael Arguedas, Morgan Quigley, dhood

 -- Chris Lalancette <clalancette@openrobotics.org>  Fri, 08 Dec 2017 00:00:00 -0000

=== debian/control ===
Source: ros-foxy-rttest
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rttest
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ros-workspace
Description: Instrumentation library for real-time performance testing

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rttest//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
